#include <libnotify/notify.h>
#include <locale.h>
#include <glib/gi18n.h>
#include <stdlib.h>
#include <stdio.h>
#include <syslog.h>
#include <sys/types.h>
#include <dlfcn.h>
#include <unistd.h>

gchar *msg_body = NULL;

static void
notify_alarm ()
{
        NotifyNotification *notification;
	notify_init("Alarm");
        notification = notify_notification_new ("警告", msg_body, "mail-mark-important");
        notify_notification_set_timeout (notification, 5000);
        notify_notification_set_urgency (notification, NOTIFY_URGENCY_CRITICAL);
        notify_notification_show (notification, NULL);
	g_object_unref(G_OBJECT(notification));
	notify_uninit();
}

static int
disk_space_check (char *location)
{
	FILE *stream = NULL;
	char buff[1024] = {0};
	gchar *cmdline;
	int capacity = 0;

	cmdline = g_strdup_printf ("df -Th %s | grep %s | awk -F ' ' '{print $6}' | sed 's/%//g'", location, location);
	// g_print ("%s,%d,cmdline:%s\n",__func__,__LINE__,cmdline);
	stream = popen (cmdline, "r");
	g_free (cmdline);
	if (stream != NULL)
	{
		fread (buff, 1, sizeof (buff), stream);
		pclose (stream);
		if (buff != NULL)
		{
			g_strstrip (buff);
			capacity = atoi(buff);
			// g_print ("%s,%d,buff:%s, capacity:%d\n",__func__,__LINE__,buff, capacity);
			if(capacity >= 95)
    			{
    				if (msg_body != NULL)
					msg_body = g_strdup_printf ("%s%s 分区的磁盘空间已经达到 %d%!\n",msg_body, location, capacity);
				else
					msg_body = g_strdup_printf ("%s 分区的磁盘空间已经达到 %d%!\n",location, capacity);
				openlog("disk-space-alarm", LOG_CONS | LOG_PID, 0);
        			syslog(LOG_WARNING, "<Critical> Very Low Disk Space on %s, Please clean immediately!\n", location);
        			closelog();
    			}
	    		else if(capacity >= 80)
    			{
    				if (msg_body != NULL)
					msg_body = g_strdup_printf ("%s%s 分区的磁盘空间已经达到 %d%!\n",msg_body, location, capacity);
				else
					msg_body = g_strdup_printf ("%s 分区的磁盘空间已经达到 %d%!\n",location, capacity);
				openlog("disk-space-alarm:", LOG_CONS | LOG_PID, 0);
        			syslog(LOG_WARNING, "<Warning> Low Disk Space on %s, Please clean immediately!\n", location);
       				closelog();
    			}
		}
	}

	// g_print ("%s,%d,msg_body:%s\n",__func__,__LINE__,msg_body);
	return 0;
}

int main()
{
	while (1)
	{
		disk_space_check("/var/log");
		disk_space_check("/");
		disk_space_check("/home");

		if (msg_body != NULL)
		{
			msg_body = g_strdup_printf ("%s请尽快清理磁盘空间", msg_body);
			notify_alarm ();
			g_free (msg_body);
			msg_body = NULL;
		}

		sleep(300);
	}
	return 0;
}
